#include "env.h"
#include "stat.h"

double
env_out(struct stat_rec *stat, double sec)
{
	struct note_rec *nt;
	struct env_rec *e;
	double v;

	nt = stat->nt;
	e = &stat->tone_compo->tone->env;
	if(nt->onoff){
		sec -= nt->on_sec;
		if(sec < e->attack){
			v = sec / e->attack;
			return log10(1 + v * 9);
		}
		sec -= e->attack;
		if(sec < e->decay){
			v = sec / e->decay;
			v = log10(1 + v * 9);
			return 1 - v * (1 - e->sustain);
		}
		return e->sustain;
	}
	sec -= nt->off_sec;
	if(sec < e->release){
		v = sec / e->release;
		v = log10(1 + v * 9);
		return (1 - v) * stat->off_v;
	}
	return 0;
}

/* EOF */
