#include "rd.h"

int bk_buf = -1;

int
rd(void)
{
	int v;

	if((v = bk_buf) < 0) return getchar();
	bk_buf = -1;
	return v;
}

void
bk(int v)
{
	if(bk_buf >= 0) ERR("give up");
	bk_buf = v;
}

void
rd_str(int n, char *s)
{
	int i;

	for(i=0; i<n; i++) s[i] = rd();
	s[i] = '\0';
}

int
rd_str_chk(int n, char *s)
{
	char buf[256];

	rd_str(n, buf);
	return strcmp(buf, s) == 0;
}

int
rd_int(int n) /* big endian */
{
	int i, v;

	v = 0;
	for(i=0; i<n; i++) v = (v << 8) | rd();
	return v;
}

int
rd_delta(void)
{
	int v, c;

	v = 0;
	do{
		if((c = rd()) == EOF) return EOF;
		v = (v << 7) | (c & 0x7f);
	}while(c & 0x80);
	return v;
}

/* EOF */
