#include "stat.h"

struct stat_rec stat_buf[ STAT_BUF_N ];

void
stat_init(struct stat_rec *stat, double sec)
{
	int i;
	struct vco_stat_rec *vco;

	for(i=0; i<2; i++){
		vco = &stat->vco[i];
		vco->cycle = 0;
		vco->sec = sec;
	}
	for(i=0; i<2; i++){
		stat->filter[i].idx = -1;
	}
	stat->fst_smp_cnt = -1;
}

void
stat_buf_init(void)
{
	int i;

	for(i=0; i<STAT_BUF_N; i++) stat_buf[i].nt = NULL;
}

void
stat_lst_free(struct stat_rec *stat)
{
	if(!stat) return;
	stat->nt = NULL;
	stat_lst_free(stat->next);
}

struct stat_rec *
stat_lst_alloc_init(int n, double sec, struct note_rec *nt, struct tone_compo_rec *tone_compo_arr, struct stat_rec *next)
{
	struct stat_rec *stat;
	int i;

	if(n > 1){
		next = stat_lst_alloc_init(n - 1, sec, nt, tone_compo_arr + 1, next);
		if(next == NULL) return NULL;
	}
	for(i=0; i<STAT_BUF_N; i++) if(stat_buf[i].nt == NULL) break;
	if(i >= STAT_BUF_N){
		stat_lst_free(next);
		return NULL;
	}
	stat = &stat_buf[i];
	stat->nt = nt;
	stat->tone_compo = tone_compo_arr;
	stat->next = next;
	stat_init(stat, sec);
	return stat;
}

/* EOF */
