#ifndef __TONE_H__
#define __TONE_H__

#include "vco.h"
#include "filter.h"
#include "env.h"
#include "modu.h"
#include "lfo.h"
#include "delay.h"

struct tone_rec{
	struct vco_rec vco;
	struct filter_rec fl1, fl2;
	struct env_rec env;
	double level;
	struct modu_rec lfo_modu;
	struct lfo_rec lfo;
	struct modu_rec env_modu;
	struct delay_rec delay;
	int chorus;
};

struct tone_compo_rec{
	struct tone_rec *tone;
	int note; /* -1 : event note */
	double rate;
};

extern struct tone_rec tone_inf[], drum_tone_inf[];
struct tone_compo_rec *tone_compo_get(int ch, int note, int *ret_n);
double tone_out(struct stat_rec *stat, double freq, double env_v);

#endif
