#ifndef __UTIL_H__
#define __UTIL_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MSG(s) fprintf(stderr, "%s() %s L%d : %s\n", __func__, __FILE__, __LINE__, s)
#define ERR(s) do{ fprintf(stderr, "ERR "); MSG(s); exit(1); }while(0)

#define OFF		0
#define ON		1

#define MIX(a, b, rate)		( (a) * (1 - (rate)) + (b) * (rate) )

int opt_idx(char *key, int ac, char **av);
char *opt_str(char *key, int ac, char **av, char *def);
int opt_int(char *key, int ac, char **av, int def);

#endif
