#include "wave.h"

double
wave_out(int wave, double cycle)
{
	cycle -= (int)cycle;

	switch(wave){
	case WAVE_SIN:
		return sin(2 * M_PI * cycle);
	case WAVE_SAW:
		cycle *= 2;
		if(cycle > 1) cycle -= 2;
		return cycle;
	case WAVE_SQUARE:
		return cycle < 0.5 ? 1 : -1;
	case WAVE_NOISE:
		return ((double)rand() / RAND_MAX) * 2 - 1;
	}
	return 0;
}

/* EOF */
